org.apache.geode.admin

## Interface GemFireHealth

- Deprecated.
  as of 7.0 use the `management` package instead

      public interface GemFireHealth

  Provides information about the aggregate health of the members of a GemFire distributed system ("components"). The `getHealth` method provides an indication of the overall health. Health is expressed as one of three levels: `GOOD_HEALTH`, `OKAY_HEALTH`, and `POOR_HEALTH`. The `getDiagnosis` method provides a more detailed explanation of the cause of ill health.

  The aggregate health of the GemFire component is evaluated every so often and if certain criteria are met, then the overall health of the component changes accordingly. If any of the components is in `OKAY_HEALTH`, then the overall health is `OKAY_HEALTH`. If any of the components is in `POOR_HEALTH`, then the overall health is `POOR_HEALTH`.

  Since:
    GemFire 3.5

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `GemFireHealth.Health` Deprecated. An enumerated type for the health of GemFire.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static GemFireHealth.Health` | `GOOD_HEALTH` Deprecated. An indicator that the GemFire components are healthy.
    `static GemFireHealth.Health` | `OKAY_HEALTH` Deprecated. An indicator that one or more GemFire components is slightly unhealthy.
    `static GemFireHealth.Health` | `POOR_HEALTH` Deprecated. An indicator that one or more GemFire components is unhealthy.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Deprecated. Closes this health monitor and releases all resources associated with it.
    `GemFireHealthConfig` | `getDefaultGemFireHealthConfig()` Deprecated. Returns the `GemFireHealthConfig` for GemFire components whose configurations are not overridden on a per-host basis.
    `java.lang.String` | `getDiagnosis()` Deprecated. Returns a message that provides a description of the cause of a component's ill health.
    `DistributedSystemHealthConfig` | `getDistributedSystemHealthConfig()` Deprecated. Returns the configuration for determining the health of the distributed system itself.
    `GemFireHealthConfig` | `getGemFireHealthConfig(java.lang.String hostName)` Deprecated. Returns the `GemFireHealthConfig` for GemFire components that reside on a given host.
    `GemFireHealth.Health` | `getHealth()` Deprecated. Returns an indicator of the overall health of the GemFire components.
    `boolean` | `isClosed()` Deprecated. Returns whether or not this `GemFireHealth` is closed.
    `void` | `resetHealth()` Deprecated. Resets the overall health of the GemFire components to `GOOD_HEALTH`.
    `void` | `setDefaultGemFireHealthConfig(GemFireHealthConfig config)` Deprecated. Sets the `GemFireHealthConfig` for GemFire components whose configurations are not overridden on a per-host basis.
    `void` | `setDistributedSystemHealthConfig(DistributedSystemHealthConfig config)` Deprecated. Sets the configuration for determining the health of the distributed system itself.
    `void` | `setGemFireHealthConfig(java.lang.String hostName, GemFireHealthConfig config)` Deprecated. Sets the `GemFireHealthConfig` for GemFire components that reside on a given host.

- - ### Field Detail

    - #### GOOD_HEALTH

          static final GemFireHealth.Health GOOD_HEALTH

      Deprecated.
      An indicator that the GemFire components are healthy.
      See Also:
        `getHealth()`

    - #### OKAY_HEALTH

          static final GemFireHealth.Health OKAY_HEALTH

      Deprecated.
      An indicator that one or more GemFire components is slightly unhealthy. The problem may or may not require configuration changes and may not necessarily lead to poorer component health.
      See Also:
        `getHealth()`

    - #### POOR_HEALTH

          static final GemFireHealth.Health POOR_HEALTH

      Deprecated.
      An indicator that one or more GemFire components is unhealthy. While it may be possible for the components to recover on their own, it is likely that they will have to be restarted.
      See Also:
        `getHealth()`

  - ### Method Detail

    - #### getHealth

          GemFireHealth.Health getHealth()

      Deprecated.
      Returns an indicator of the overall health of the GemFire components.
      See Also:
        `GOOD_HEALTH`, `OKAY_HEALTH`, `POOR_HEALTH`

    - #### resetHealth

          void resetHealth()

      Deprecated.
      Resets the overall health of the GemFire components to `GOOD_HEALTH`. This operation should be invoked when the operator has determined that warnings about the components's health do not need to be regarded.

    - #### getDiagnosis

          java.lang.String getDiagnosis()

      Deprecated.
      Returns a message that provides a description of the cause of a component's ill health.

    - #### getDistributedSystemHealthConfig

          DistributedSystemHealthConfig getDistributedSystemHealthConfig()

      Deprecated.
      Returns the configuration for determining the health of the distributed system itself.

    - #### setDistributedSystemHealthConfig

          void setDistributedSystemHealthConfig(DistributedSystemHealthConfig config)

      Deprecated.
      Sets the configuration for determining the health of the distributed system itself.

    - #### getDefaultGemFireHealthConfig

          GemFireHealthConfig getDefaultGemFireHealthConfig()

      Deprecated.
      Returns the `GemFireHealthConfig` for GemFire components whose configurations are not overridden on a per-host basis. Note that changes made to the returned `GemFireHealthConfig` will not take effect until `setDefaultGemFireHealthConfig(org.apache.geode.admin.GemFireHealthConfig)` is invoked.

    - #### setDefaultGemFireHealthConfig

          void setDefaultGemFireHealthConfig(GemFireHealthConfig config)

      Deprecated.
      Sets the `GemFireHealthConfig` for GemFire components whose configurations are not overridden on a per-host basis.
      Throws:
        `java.lang.IllegalArgumentException` - If `config` specifies the config for a host

    - #### getGemFireHealthConfig

          GemFireHealthConfig getGemFireHealthConfig(java.lang.String hostName)

      Deprecated.
      Returns the `GemFireHealthConfig` for GemFire components that reside on a given host. This configuration will override the default configuration.
      Parameters:
        `hostName` - The canonical name of the host.

    - #### setGemFireHealthConfig

          void setGemFireHealthConfig(java.lang.String hostName,
                                      GemFireHealthConfig config)

      Deprecated.
      Sets the `GemFireHealthConfig` for GemFire components that reside on a given host. This configuration will override the default configuration. Note that changes made to the returned `GemFireHealthConfig` will not take effect until `setDefaultGemFireHealthConfig(org.apache.geode.admin.GemFireHealthConfig)` is invoked.
      Parameters:
        `hostName` - The canonical name of the host.
      Throws:
        `java.lang.IllegalArgumentException` - If host `hostName` does not exist or if there are no GemFire components running on that host or if `config` does not configure host `hostName`.

    - #### close

          void close()

      Deprecated.
      Closes this health monitor and releases all resources associated with it.

    - #### isClosed

          boolean isClosed()

      Deprecated.
      Returns whether or not this `GemFireHealth` is closed.